Package org.apache.sis.metadata.iso.distribution

# Class DefaultDistribution

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultDistribution

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `Distribution`

@TitleProperty(name="description") public class DefaultDistribution extends ISOMetadata implements Distribution
Information about the distributor of and options for obtaining the resource. The following properties are mandatory or conditional (i.e. mandatory under some circumstances) in a well-formed metadata according ISO 19115:
`MD_Distribution` `└─distributionFormat………………………………………` Description of the format of the data to be distributed. `└─formatSpecificationCitation……` Citation/URL of the specification format. `├─title……………………………………………………` Name by which the cited resource is known. `└─date………………………………………………………` Reference date for the cited resource.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultDistribution()`
  Constructs an initially empty distribution.
  `DefaultDistribution(Distribution object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultDistribution`
  `castOrCopy(Distribution object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `InternationalString`
  `getDescription()`
  Returns a brief description of a set of distribution options.
  `Collection<Format>`
  `getDistributionFormats()`
  Provides a description of the format of the data to be distributed.
  `Collection<Distributor>`
  `getDistributors()`
  Provides information about the distributor.
  `Collection<DigitalTransferOptions>`
  `getTransferOptions()`
  Provides information about technical means and media by which a resource is obtained from the distributor.
  `void`
  `setDescription(InternationalString newValue)`
  Sets a brief description of a set of distribution options.
  `void`
  `setDistributionFormats(Collection<? extends Format> newValues)`
  Sets a description of the format of the data to be distributed.
  `void`
  `setDistributors(Collection<? extends Distributor> newValues)`
  Sets information about the distributor.
  `void`
  `setTransferOptions(Collection<? extends DigitalTransferOptions> newValues)`
  Sets information about technical means and media by which a resource is obtained from the distributor.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultDistribution

    public DefaultDistribution()
    Constructs an initially empty distribution.

  - ### DefaultDistribution

    public DefaultDistribution(Distribution object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(Distribution)`

- ## Method Details

  - ### castOrCopy

    public static DefaultDistribution castOrCopy(Distribution object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultDistribution`, then it is returned unchanged.
    - Otherwise a new `DefaultDistribution` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getDescription

    @UML(identifier="description", obligation=OPTIONAL, specification=ISO_19115) public InternationalString getDescription()
    Returns a brief description of a set of distribution options.
    Returns:
      brief description of a set of distribution options.
    Since:
      0.5

  - ### setDescription

    public void setDescription(InternationalString newValue)
    Sets a brief description of a set of distribution options.
    Parameters:
      `newValue` - the new description.
    Since:
      0.5

  - ### getDistributionFormats

    public Collection<Format> getDistributionFormats()
    Provides a description of the format of the data to be distributed.
    Specified by:
      `getDistributionFormats` in interface `Distribution`
    Returns:
      description of the format of the data to be distributed.
    See Also:
      - `AbstractIdentification​.getResourceFormats()`

  - ### setDistributionFormats

    public void setDistributionFormats(Collection<? extends Format> newValues)
    Sets a description of the format of the data to be distributed.
    Parameters:
      `newValues` - the new distribution formats.
    See Also:
      - `AbstractIdentification​.setResourceFormats(Collection)`

  - ### getDistributors

    public Collection<Distributor> getDistributors()
    Provides information about the distributor.
    Specified by:
      `getDistributors` in interface `Distribution`
    Returns:
      information about the distributor.

  - ### setDistributors

    public void setDistributors(Collection<? extends Distributor> newValues)
    Sets information about the distributor.
    Parameters:
      `newValues` - the new distributors.

  - ### getTransferOptions

    public Collection<DigitalTransferOptions> getTransferOptions()
    Provides information about technical means and media by which a resource is obtained from the distributor.
    Specified by:
      `getTransferOptions` in interface `Distribution`
    Returns:
      technical means and media by which a resource is obtained from the distributor.

  - ### setTransferOptions

    public void setTransferOptions(Collection<? extends DigitalTransferOptions> newValues)
    Sets information about technical means and media by which a resource is obtained from the distributor.
    Parameters:
      `newValues` - the new transfer options.